package cn.timer.api.bean.insure;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;



/**
 * 支付流水表
 *
 * @author wgd
 * @email 862422848@qq.com
 * @date 2022-05-18 19:33:23
 */
@Entity
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Table(name = "insure_pay")
@ApiModel("支付流水表")
public class InsurePay extends Model<InsurePay> {
	private static final long serialVersionUID = 1L;

	/**
	* id
	*/
	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "编号")
	private Integer id;
	/**
	* 1已支付 2未支付 3已超时
	*/
	private Integer payStatus;
	/**
	* 支付金额
	*/
	private Double amount;
	/**
	* 支付时间
	*/
	private Date payTime;
	/**
	* 超时时间
	*/
	private Date endTime;
	/**
	* 支付流水号
	*/
	private String paySerialNo;
	/**
	* 支付类型
	*/
	private String payType;

	private Integer policyId;

	private String serialNumber;

	/**
	 * 设置：id
	 */
	public void setId(Integer id) {
		this.id = id;
	}
	/**
	 * 获取：id
	 */
	public Integer getId() {
		return id;
	}
	/**
	 * 设置：1已支付 2未支付 3已超时
	 */
	public void setPayStatus(Integer payStatus) {
		this.payStatus = payStatus;
	}
	/**
	 * 获取：1已支付 2未支付 3已超时
	 */
	public Integer getPayStatus() {
		return payStatus;
	}
	/**
	 * 设置：支付金额
	 */
	public void setAmount(Double amount) {
		this.amount = amount;
	}
	/**
	 * 获取：支付金额
	 */
	public Double getAmount() {
		return amount;
	}
	/**
	 * 设置：支付时间
	 */
	public void setPayTime(Date payTime) {
		this.payTime = payTime;
	}
	/**
	 * 获取：支付时间
	 */
	public Date getPayTime() {
		return payTime;
	}
	/**
	 * 设置：超时时间
	 */
	public void setEndTime(Date endTime) {
		this.endTime = endTime;
	}
	/**
	 * 获取：超时时间
	 */
	public Date getEndTime() {
		return endTime;
	}
	/**
	 * 设置：支付流水号
	 */
	public void setPaySerialNo(String paySerialNo) {
		this.paySerialNo = paySerialNo;
	}
	/**
	 * 获取：支付流水号
	 */
	public String getPaySerialNo() {
		return paySerialNo;
	}
	/**
	 * 设置：支付类型
	 */
	public void setPayType(String payType) {
		this.payType = payType;
	}
	/**
	 * 获取：支付类型
	 */
	public String getPayType() {
		return payType;
	}
}
