package cn.timer.api.bean.insure;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;



/**
 * 保险产品
 *
 * @author wgd
 * @email 862422848@qq.com
 * @date 2022-03-30 11:36:30
 */
@Entity
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Table(name = "insure_product")
@ApiModel("保险产品")
public class InsureProduct extends Model<InsureProduct> {
	private static final long serialVersionUID = 1L;

	/**
	* id
	*/
	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "编号")
	private Integer id;
	/**
	* 产品名称
	*/
	private String name;
	/**
	* 计划代码
	*/
	private String planCodeId;
	/**
	* 产品代码
	*/
	private String productCodeId;
	/**
	* 类型:1年单 2月单
	*/
	private Integer type;
	/**
	* 创建时间
	*/
	private Date createTime;
	/**
	* 是否删除 0否 1是
	*/
	private Integer isDel;

	/**
	 * 1 在线支付 2预付款 3线下支付
	 */
	private Integer payType;

	/**
	 * 设置：id
	 */
	public void setId(Integer id) {
		this.id = id;
	}
	/**
	 * 获取：id
	 */
	public Integer getId() {
		return id;
	}
	/**
	 * 设置：产品名称
	 */
	public void setName(String name) {
		this.name = name;
	}
	/**
	 * 获取：产品名称
	 */
	public String getName() {
		return name;
	}
	/**
	 * 设置：计划代码
	 */
	public void setPlanCodeId(String planCodeId) {
		this.planCodeId = planCodeId;
	}
	/**
	 * 获取：计划代码
	 */
	public String getPlanCodeId() {
		return planCodeId;
	}
	/**
	 * 设置：产品代码
	 */
	public void setProductCodeId(String productCodeId) {
		this.productCodeId = productCodeId;
	}
	/**
	 * 获取：产品代码
	 */
	public String getProductCodeId() {
		return productCodeId;
	}
	/**
	 * 设置：类型:1年单 2月单
	 */
	public void setType(Integer type) {
		this.type = type;
	}
	/**
	 * 获取：类型:1年单 2月单
	 */
	public Integer getType() {
		return type;
	}
	/**
	 * 设置：创建时间
	 */
	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}
	/**
	 * 获取：创建时间
	 */
	public Date getCreateTime() {
		return createTime;
	}
	/**
	 * 设置：是否删除 0否 1是
	 */
	public void setIsDel(Integer isDel) {
		this.isDel = isDel;
	}
	/**
	 * 获取：是否删除 0否 1是
	 */
	public Integer getIsDel() {
		return isDel;
	}
}
